﻿using System;
using System.Collections;
using System.Linq;
using System.Text;

namespace DotNetMapReducer
{
    // used for callbacks for the OutputCollector
    public delegate void collectResult(string theKey, int theValue);

    // used for callbacks to the Iterator
    public delegate object getNextValue();  // returns null if no more values, returns boxed integer otherwise

    public class DotNetMapReducer
    {
        public void map(string line, collectResult resultCollector)
        {
            Console.WriteLine("In DotNetMapReducer.map()");
            StringTokenizer st = new StringTokenizer(line);
            while (st.hasMoreTokens())
            {
                string nextToken = st.nextToken();
                resultCollector(nextToken, 1);
            }
        }

        public void reduce(string key, getNextValue next, collectResult resultCollector)
        {
            Console.WriteLine("In DotNetMapReducer.reduce()");
            int sum = 0;
            object nextValue = next();  // get the next one, if there
            while (nextValue != null)
            {
                sum += (int)nextValue;
                nextValue = next();
            }

            resultCollector(key, sum);
        }
    }
}
