import java.io.IOException;
import java.util.Iterator;

import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapred.MapReduceBase;
import org.apache.hadoop.mapred.OutputCollector;
import org.apache.hadoop.mapred.Reducer;
import org.apache.hadoop.mapred.Reporter;
import DotNetMapReducer.DotNetMapReducer;
import System.Collections.ArrayList;
import System.BoxedInt;
import com.jnbridge.jnbcore.Callbacks;

public class ReducerWrapper extends MapReduceBase
implements Reducer<Text, IntWritable, Text, IntWritable> {
	
	private static MapReducerHelper mrh = new MapReducerHelper();

	private DotNetMapReducer dnmr = new DotNetMapReducer();
	
	public void reduce(Text key, Iterator<IntWritable> values,
	                   OutputCollector<Text, IntWritable> output, 
	                   Reporter reporter) throws IOException {

	  IteratorHandler ih = new IteratorHandler(values);
	  OutputCollectorHandler och = new OutputCollectorHandler(output);
	  
	  dnmr.reduce(key.toString(), ih, och);
	  
	  Callbacks.releaseCallback(ih);
	  Callbacks.releaseCallback(och);
	}
}
